//kmatrice_es.c
//Version: 0.0.9     02 July 2016
//Escrito por: Daniel Arroyo <kmatrice@gmail.com>
//Esta versin esta en desarrollo, usenla con precaucin

#include <stdio.h>  //libreria estandar, funciones de entrada y salida
#define MAXLEN 100  //MAXLEN igual a 100; MAXLEN = 100
#define ARRAY 51    //ARRAY igual a 51; ARRAY = 51
#define NAMELEN 14  //NAMELEN igual a 14; NAMELEN = 14
//estructura matrices, almacena las matrices ingresadas
struct matrices
{
  char name[NAMELEN];
  int row, col;
  float matrice[MAXLEN][MAXLEN];
};
struct matrices Matrice[ARRAY];
//Variables de tipo entero (int)
int i, j, k = 0, l = 0, m, n, q;
//Variables de tipo punto flotante (float)
float N, det, o, s, Identy[MAXLEN][MAXLEN], Result[MAXLEN][MAXLEN];
//Variables de tipo caracter (char)
char s_copy[NAMELEN], Q;
//Funcin principal ejecuta la lnea de comandos
int main()
{
  printWelcome();
  commandline();
  return(0);
}
//Lnea de comandos esta compuesta por un ciclo while y la funcin enter
commandline()
{
  do {
    printf("kmatrice>>");
    funenter();
  } while(Q != 'q' && Q != 'Q');
  printAbout();
  return;
}
//la funcin enter nos permite evaluar los comandos ingresados
funenter()
{
  //15 comandos disponibles
  int about, help, quit, deter, inver, traza, trans,
    randm, ident, showa, cmp, suma, rest, mult,
    mescal, equal, compare;
  char name[NAMELEN];
  scanf("%s", s_copy);
  strcmp(name, s_copy);
  quit = strcmp(s_copy, "quit");
  if(quit == 0) {Q = 'q'; return;}
  quit = strcmp(s_copy, "q");
  if(quit == 0) {Q = 'q'; return;}
  quit = strcmp(s_copy, "Q");
  if(quit == 0) {Q = 'Q'; return;}
  for(i = 0; i < k; i++)
    {
      compare = strcmp(Matrice[i].name, s_copy);
      if(compare == 0)
	{
	  l = i;
	  funprint(l);
	  return;
	}
    }
  deter = strcmp(s_copy, "deter");
  if(deter == 0) {fundeter(); return;}
  inver = strcmp(s_copy, "inver");
  if(inver == 0) {funinver(); return;}
  traza = strcmp(s_copy, "traza");
  if(traza == 0) {funtraza(); return;}
  trans = strcmp(s_copy, "trans");
  if(trans == 0) {funtrans(k); return;}
  randm = strcmp(s_copy, "rand");
  if(randm == 0) {funrand(k); return;}
  ident = strcmp(s_copy, "ident");
  if(ident == 0) {funiden(k); return;}
  showa = strcmp(s_copy, "show");
  if(showa == 0) {funshowa(); return;}
  about = strcmp(s_copy, "about");
  if(about == 0) {printAbout(); return;}
  help = strcmp(s_copy, "help");
  if(help == 0) {printHelp(); return;}
  suma  = strcmp(s_copy, "sum");
  if(suma == 0) {s_copy[1] = '+'; funsuma(k, i); return;}
  rest  = strcmp(s_copy, "rest");
  if(rest == 0) {s_copy[1] = '-'; funsuma(k, i); return;}
  mult  = strcmp(s_copy, "mult");
  if(mult == 0) {s_copy[1] = '*'; funmult(k, i); return;}
  mescal = strcmp(s_copy, "escal");
  if(mescal == 0) {funescal(k); return;}
  equal = strcmp(s_copy, "equal");
  if(equal == 0) {funequal(k, i); return;}
  if(l == i && l == 0 && i == 0) funintro(k);
  if(l != i) funintro(k);
  return;
}
//Ingresar una matriz, primero el nombre, despues las filas y las
//columnas
funintro(int no)
{
  strcpy(Matrice[k].name, s_copy);
  printf("Quieres ingresar la matriz [%s] (s/n)? ", s_copy);
  char n_y = getchar();
  if ((n_y = getchar()) == 's')
    {
      printf("Introduce el numero de renglones para [%s]mx_ (entero): ", s_copy);
      scanf("%d", &Matrice[no].row);
      printf("Introduce el numero de columnas para [%s]_xn (entero): ", s_copy);
      scanf("%d", &Matrice[no].col);
      funrcerr(no);
      printf("Ahora introduce los elementos por renglon.\n");
      for (m = 0; m < Matrice[no].row; m++)
        {
	  printf("R%d  ", m + 1);
	  for (n = 0; n < Matrice[no].col; n++)
            {
	      scanf("%f", &N);
	      Identy[m][n] = N;
	      Matrice[no].matrice[m][n] = Identy[m][n];
            }
        }
      funprint(k);
      k++;
      l = k - 1;
    }
  return;
}
//imprime una matriz previamente ingresada, solo se debe ingresar el
//nombre de la matriz
funprint(int no)
{
  if(Matrice[no].col > 0 && Matrice[no].row > 0)
    {
      funmatr(no);
      for (m = 0; m < Matrice[no].row; m++)
	{
	  putchar('\t');
	  for (n = 0; n < Matrice[no].col; n++) printf("%3.2f  ", Matrice[no].matrice[m][n]);
	  putchar('\n');
	}
    } else funwoutv();
  return;
}
//Genera una matriz identidad, primero el nombre, despues el nmero de
//filas debe ser igual al de columnas
funiden(int no)
{
  int compare;
  char name[NAMELEN], s_copy[NAMELEN];
  scanf("%s", s_copy);
  strcpy(name, s_copy);
  for(i = 0; i < k; i++)
    {
      compare = strcmp(Matrice[i].name, name);
      if(compare == 0)
	{
	  no = i;
	  break;
	}
    }
  strcpy(Matrice[no].name, name);
  scanf("%d", &Matrice[no].row);
  funrerr(no);
  Matrice[no].col = Matrice[no].row;
  for(m = 0; m < Matrice[no].row; m++)
    {
      for(n = 0; n < Matrice[no].col; n++)
	{
	  if(m == n) Identy[m][n] = 1;
	  else Identy[m][n] = 0;
	  Matrice[no].matrice[m][n] = Identy[m][n];
	}
    }
  funprint(no);
  k++;
  l = k - 1;
  return;
}
//Genera una matriz con elementos aleatorios, primero el nombre, despues
//las filas y las columnas
funrand(int no)
{
  int compare, random;
  char name[NAMELEN], s_copy[NAMELEN], n_y;
  printf("Quieres generar una matriz con elementos aleatorios (s/n)? ");
  n_y = getchar();
  if ((n_y = getchar()) == 's')
    {
      printf("Escribe el nombre de la matriz (letras): ");
      scanf("%s", s_copy);
      strcpy(name, s_copy);
      for(i = 0; i < k; i++)
        {
	  compare = strcmp(Matrice[i].name, name);
	  if(compare == 0)
            {
	      no = i;
	      break;
            }
        }
      strcpy(Matrice[no].name, name);
      printf("Introduce el numero de renglones para [%s]mx_ (entero): ", s_copy);
      scanf("%d", &Matrice[no].row);
      printf("Introduce el numero de columnas para [%s]_xn (entero): ", s_copy);
      scanf("%d", &Matrice[no].col);
      printf("Introduce el limite del rango (entero): ");
      scanf("%d", &random);
      for (m = 0; m < Matrice[no].row; m++)
        {
	  for (n = 0; n < Matrice[no].col; n++)
            {
	      Identy[m][n] = rand()%random;
	      Matrice[no].matrice[m][n] = Identy[m][n];
            }
        }
      funprint(no);
      k++;
      l = k - 1;
    }
  return;
}
//Asigna el valor nmerico del total de elementos de una matriz a otra
funequal(int no_o, int no_t)
{
  no_o = funarchm();
  no_t = funarchm();
  Matrice[no_t].row = Matrice[no_o].row;
  Matrice[no_t].col = Matrice[no_o].col;
  for (m = 0; m < Matrice[no_o].row; m++)
    for (n = 0; n < Matrice[no_o].col; n++)
      Matrice[no_t].matrice[m][n] = Matrice[no_o].matrice[m][n];
  funprint(no_t);
  return;
}
//realiza la suma y la resta de dos matrices tambin puedes guardar
//el resultado en otra matriz
funsuma(int no_o, int no_t)
{
  no_o = funarchm();
  no_t = funarchm();
  if (Matrice[no_o].row != Matrice[no_t].row ||
      Matrice[no_o].col != Matrice[no_t].col)
      fundimnc(no_o, no_t);
  else
    {
      for (m = 0; m < Matrice[no_o].row; m++)
	{
	  for (n = 0; n < Matrice[no_t].col; n++)
	    {
	      if(s_copy[1] == '-')
		{
		  Result[m][n] = Matrice[no_o].matrice[m][n] - Matrice[no_t].matrice[m][n];
		  printf("%3.1f-%3.1f  ", Matrice[no_o].matrice[m][n], Matrice[no_t].matrice[m][n]);
		}
	      else
		{
		  Result[m][n] = Matrice[no_o].matrice[m][n] + Matrice[no_t].matrice[m][n];
		  printf("%3.1f+%3.1f  ", Matrice[no_o].matrice[m][n], Matrice[no_t].matrice[m][n]);
		}
	    }
	  putchar('\n');
	}
      putchar('\n');
      printf("[%s]%dx%d %c [%s]%dx%d = [R]%dx%d\n",
	     Matrice[no_o].name, Matrice[no_o].row, Matrice[no_t].col,
	     s_copy[1],
	     Matrice[no_t].name, Matrice[no_t].row, Matrice[no_t].col,
	     Matrice[no_o].row, Matrice[no_t].col);
      strcpy(Matrice[ARRAY].name, "R");
      Matrice[ARRAY].row = Matrice[no_o].row;
      Matrice[ARRAY].col = Matrice[no_t].col;
      for (m = 0; m < Matrice[ARRAY].row; m++)
	{
	  putchar('\t');
	  for (n = 0; n < Matrice[ARRAY].col; n++)
	    {
	      Matrice[ARRAY].matrice[m][n] = Result[m][n];
	      printf("%3.2f  ", Result[m][n]);
	    }
	  putchar('\n');
	}
      printf("Asignar el resultado a otra matriz (s/n)? ");
      char n_y = getchar();
      if ((n_y = getchar()) == 's')
	{
	  printf("Escribe el nombre de la matriz: ");
	  char name[NAMELEN], s_copy[NAMELEN]; int no = k++;
	  scanf("%s", s_copy);
	  strcpy(name, s_copy);
	  strcpy(Matrice[no].name, name);
	  Matrice[no].col = Matrice[no_t].col;
	  Matrice[no].row = Matrice[no_t].row;
	  for (m = 0; m < Matrice[no].row; m++)
	    for (n = 0; n < Matrice[no].col; n++)
	      Matrice[no].matrice[m][n] = Matrice[ARRAY].matrice[m][n];
	  printf("Asignacion exitosa.\n");
	}
    }
  return;
}
//Multiplica dos matrices, puedes guardar el resultado en una nueva matriz
funmult(int no_o, int no_t)
{
  no_o = funarchm();
  no_t = funarchm();
  if (Matrice[no_o].col != Matrice[no_t].row)
    fundimnc(no_o, no_t);
  else
    {
      o = 0;
      det = 0;
      for (q = 0; q < Matrice[no_t].col; q++)
	{
	  for (m = 0; m < Matrice[no_o].row; m++)
	    {
	      for (n = 0; n < Matrice[no_o].col; n++)
		{
		  o = Matrice[no_o].matrice[m][n] * Matrice[no_t].matrice[n][q];
		  det = det + o;
		    printf("%3.1f*%3.1f", Matrice[no_o].matrice[m][n], Matrice[no_t].matrice[n][q]);
		      if(n < Matrice[no_o].col - 1) printf("+");
		}
		printf("=%3.1f", det);
		Matrice[ARRAY].matrice[m][q] = det;
		det = 0;
		  putchar('\n');
	    }
	  putchar('\n');
	}
      printf("[%s]%dx%d * [%s]%dx%d = [R]%dx%d\n",
	     Matrice[no_o].name, Matrice[no_o].row, Matrice[no_o].col, Matrice[no_t].name, Matrice[no_t].row, Matrice[no_t].col, Matrice[no_o].row, Matrice[no_t].col);
      strcpy(Matrice[ARRAY].name, "R");
      Matrice[ARRAY].row = Matrice[no_o].row;
      Matrice[ARRAY].col = Matrice[no_t].col;
      for (n = 0; n < Matrice[ARRAY].row; n++)
	{
	  putchar('\t');
	  for (m = 0; m < Matrice[ARRAY].col; m++)
	    {
	      Result[n][m] = Matrice[ARRAY].matrice[n][m];
	      printf("%3.2f  ", Matrice[ARRAY].matrice[n][m]);
	    }
	  putchar('\n');
	}
      printf("Asignar el resultado a otra matriz (s/n)? ");
      char n_y = getchar();
      if ((n_y = getchar()) == 's')
	{
	  printf("Escribe el nombre de la matriz: ");
	  char name[NAMELEN], s_copy[NAMELEN]; int no = k++;
	  scanf("%s", s_copy);
	  strcpy(name, s_copy);
	  strcpy(Matrice[no].name, name);
	  Matrice[no].row = Matrice[no_o].row;
	  Matrice[no].col = Matrice[no_t].col;
	  for (n = 0; n < Matrice[no].row; n++)
	    for (m = 0; m < Matrice[no].col; m++)
	      Matrice[no].matrice[n][m] = Result[n][m];
	  printf("Asignacion exitosa.\n");
	}
    }
  return;
}
//Calcula el determinante de la matriz por medio del mtodo de
//Gauss-Jordan
fundeter()
{
  int no =  funarchm();
  if(Matrice[no].col == Matrice[no].row && Matrice[no].col > 0 && Matrice[no].row > 0)
    {
      funassig(no);
      if(det == 0) goto msg;
      funmrow(no);
      funmulin(no);
      if(det == 0) {Matrice[no].col = Matrice[no].col / 2; goto msg;}
      Matrice[no].col = Matrice[no].col / 2;
      det = 1;
      for (m = 0; m < Matrice[no].row; m++)
	{
	  for (n = 0; n < Matrice[no].col; n++)
	    {
	      if (m == n)
		{
		  o = Result[m][n];
		  det = o * det;
		}
	    }
	}
    msg:
      printf("\ndet[%s]nn=det[%s]%dx%d= %3.2f\n"
	     , Matrice[no].name, Matrice[no].name, Matrice[no].row, Matrice[no].col, det);
    } else fundimerr(no);
  return;
}
//Calcula la inversa de una matriz cuadrada por medio del mtodo de
//Gauss-Jordan tambin puedes guardar dicha matriz a una nueva
funinver()
{
  int no = funarchm();
  if(Matrice[no].col == Matrice[no].row && Matrice[no].col > 0 && Matrice[no].row > 0)
    {
      funassig(no);
      if(det == 0) {printf("\nMatriz singular.\n"); return;}
      funmrow(no);
      funmulin(no);
      if(det == 0) {printf("\nMatriz singular.\n");
	Matrice[no].col = Matrice[no].col / 2; return;}
      for(m = 0; m < Matrice[no].row; m++)
	{
	  for(n = 0; n < Matrice[no].col; n++)
	    {
	      if(m == n) o = Result[m][n];
	      if(Result[m][n] == 0) Result[m][n] = 0;
	      else
		{if(o == 1) Result[m][n] = Result[m][n];
		  else
		    Result[m][n] = Result[m][n] * (1 / o);}
	    }
	}
      for(m = 0; m < Matrice[no].row; m++)
	for(n = Matrice[no].row; n < Matrice[no].col; n++)
	  Identy[m][n - Matrice[no].row] = Result[m][n];
      Matrice[no].col = Matrice[no].col / 2;
      printf("\n([%s]%dx%d)^-1=\n", Matrice[no].name, Matrice[no].row, Matrice[no].col);
      for(m = 0; m < Matrice[no].row; m++)
	{
	  putchar('\t');
	  for(n = 0; n < Matrice[no].col; n++)
	    printf("%3.3f  ", Identy[m][n]);
	  putchar('\n');
	}
      printf("Asignar el resultado a otra matriz (s/n)? ");
      char n_y = getchar();
      if ((n_y = getchar()) == 's')
	{
	  printf("Escribe el nombre de la matriz? ");
	  char name[NAMELEN], s_copy[NAMELEN]; int no_t = k++;
	  scanf("%s", s_copy);
	  strcpy(name, s_copy);
	  strcpy(Matrice[no_t].name, name);
	  Matrice[no_t].col = Matrice[no].col;
	  Matrice[no_t].row = Matrice[no].row;
	  for (m = 0; m < Matrice[no_t].row; m++)
	    for (n = 0; n < Matrice[no_t].col; n++)
	      Matrice[no_t].matrice[m][n] = Identy[m][n];
	  printf("Asignacion exitosa.\n");
	}
    } else fundimerr(no);
  return;
}
//Esta funcion busca si en las matrices ingresadas
//se realiza una comparacin de cadenas y si el nombre de la matriz
//esta en alguna matriz devuelve el nmero de la matriz
funarchm()
{
  int no, compare;
  char s_copy[NAMELEN], name[NAMELEN];
  scanf("%s", s_copy);
  strcpy(name, s_copy);
  for(i = 0; i < k; i++)
    {
      compare = strcmp(Matrice[i].name, name);
      if(compare == 0)
	{
	  no = i;
	  break;
	}
    }
  //printf("%d ", no);
  if(no != i) return;
  return(no);
}
//Adiciona e imprime la matriz identidad de la matriz elegida para
//aplicar el metodo de Gauss-Jordan
funmrow(int no)
{
  Matrice[no].col = Matrice[no].row * 2;
  for(m = 0; m < Matrice[no].row; m++)
    {
      for(n = Matrice[no].row; n < Matrice[no].col; n++)
	{
	  if(m + Matrice[no].row == n)
	    {
	      Identy[m][n] = 1.00;
	      Result[m][n] = Identy[m][n];
	    }
	  else {Identy[m][n] = 0.00; Result[m][n] = Identy[m][n];}
	}
    }
  for(m = 0; m < Matrice[no].row; m++)
    {
      if(Identy[m][m] == 0.00 && m < Matrice[no].row - 1)
	{
	  for(n = 0; n < Matrice[no].col; n++)
	    {
	      Result[m][n] = Identy[m + 1][n];
	      Result[m + 1][n] = Identy[m][n];
	    }
	  for(i = 0; i < Matrice[no].row; i++)
	    for(j = 0; j < Matrice[no].col; j++)
	      Identy[i][j] = Result[i][j];
	}
    }
  if(Identy[Matrice[no].row - 1][Matrice[no].row - 1] == 0.00)
    {
      for(q = 0; q < Matrice[no].row; q++)
	{
	  if(Identy[q][Matrice[no].row - 1] != 0.00)
	    {
	      for(j = 0; j < Matrice[no].col; j++)
		{
		  Result[Matrice[no].row - 1][j] = Identy[q][j];
		  Result[q][j] = Identy[Matrice[no].row - 1][j];
		}
	      for(i = 0; i < m; i++)
		for(j = 0; j < Matrice[no].col; j++)
		  Identy[i][j] = Result[i][j];
	    }
	}
    }
  printf("\n[%s I]mn=\n", Matrice[no].name);
  for(m = 0; m < Matrice[no].row; m++)
    {
      for(n = 0; n < Matrice[no].col; n++) printf("%3.2f  ", Identy[m][n]);
      putchar('\n');
    }
  return;
}
//Realiza las transformaciones en los renglones siguiendo el metodo de
//Gauss-Jordan imprime la matriz [U L^-1]
funmulin(int no)
{
  det = 0;
  for(q = 0; q < Matrice[no].row - 1; q++)
    {
      for(m = 0 + q; m < Matrice[no].row; m++)
	{
	  for(n = 0; n < Matrice[no].col; n++)
	    {
	      if(Identy[q][q] == 0) {det = 0;
		printf("Renglones dependientes R%d y R%d.", m, m + 1); return;}
	      if(Identy[m + 1][q] == 0) det = 0;
	      else det = ((Identy[m + 1][q] * -1) / Identy[q][q]) * Identy[q][n + q];
	      det = det + Identy[m + 1][n + q];
	      Result[m + 1][n + q] = det;
	    }
	}
      for(i = 0; i < Matrice[no].row; i++)
	for(j = 0; j < Matrice[no].col; j++)
	  Identy[i][j] = Result[i][j];
    }
  det = 0;
  for(q = Matrice[no].row - 1; q > 0; q--)
    {
      for(m = q; m > 0; m--)
	{
	  for(n = 0; n < Matrice[no].col; n++)
	    {
	      if(Identy[q][q] == 0) {det = 0;
		printf("Dependencia R%d y R%d.", m, m + 1); return;}
	      if(Identy[m - 1][q] == 0) det = 0;
	      else det = ((Identy[m - 1][q] * -1) / Identy[q][q]) * Identy[q][n];
	      det = det + Identy[m - 1][n];
	      Result[m - 1][n] = det;
	    }
	}
      for(i = 0; i < Matrice[no].row; i++)
	for(j = 0; j < Matrice[no].col; j++)
	  Identy[i][j] = Result[i][j];
    }
  putchar('\n');
  printf("[U  L^-1]mn=\n");
  for(m = 0; m < Matrice[no].row; m++)
    {
      for(n = 0; n < Matrice[no].col; n++)
	{
	  printf("%3.2f ", Identy[m][n]);
	  Result[m][n] = Identy[m][n];
	}
      putchar('\n');
    }
  return;
}

funassig(int no)
{
  funprint(no);
  det = 0;
  o = 0;
  for(m = 0; m < Matrice[no].row; m++)
    {
      det = 0;
      for(n = 0; n < Matrice[no].col; n++)
	{
	  Identy[m][n] = Matrice[no].matrice[m][n];
	  Result[m][n] = Identy[m][n];
	  det = det + Identy[m][n];
	}
    }
  return;
}
//Realiza la matriz transpuesta A^T, puedes aplicar la transformacin o
//asignar el valor a otra matriz
funtrans(int no)
{
  no =  funarchm();
  funprint(no);
  putchar('\n');
  printf("[%s]mn^T=[%s]nm=[%s]%dx%d=\n",
	 Matrice[no].name, Matrice[no].name, Matrice[no].name, Matrice[no].col, Matrice[no].row);
  for (n = 0; n < Matrice[no].col; n++)
    {
      putchar('\t');
      for (m = 0; m < Matrice[no].row; m++)
	{
	  Identy[n][m] = Matrice[no].matrice[m][n];
	  printf("%3.2f  ", Identy[n][m]);
	  //Identy[n][m] = Matrice[no].matrice[n][m];
	}
      putchar('\n');
    }
  printf("Quieres aplicar la transformacion (s/n)? ");
  char n_y = getchar();
  if ((n_y = getchar()) == 's')
    {
      Matrice[no].col = m; Matrice[no].row = n;
      for (m = 0; m < Matrice[no].col; m++)
	for (n = 0; n < Matrice[no].row; n++)
	  Matrice[no].matrice[n][m] = Identy[n][m];
      printf("Transformacion aplicada.\n"); return;
    }
  printf("Asignar el resultado a otra matriz (s/n)? ");
  n_y = getchar();
  if ((n_y = getchar()) == 's')
    {
      printf("Escribe el nombre de la matriz? ");
      char name[NAMELEN], s_copy[NAMELEN]; int no_t = k++;
      scanf("%s", s_copy);
      strcpy(name, s_copy);
      strcpy(Matrice[no_t].name, name);
      Matrice[no_t].col = Matrice[no].row;
      Matrice[no_t].row = Matrice[no].col;
      for (m = 0; m < Matrice[no_t].col; m++)
	for (n = 0; n < Matrice[no_t].row; n++)
	  Matrice[no_t].matrice[n][m] = Identy[n][m];
      printf("Asignacion exitosa.\n");
    }
  return;
}
//Realiza el calculo de la traza de una matriz cuadrada, es la suma de
//los elementos de la diagonal de una matriz cuadrada
funtraza()
{
  int no = funarchm();
  if(Matrice[no].row == Matrice[no].col && Matrice[no].col > 0 && Matrice[no].row > 0)
    {
      o = 0;
      det = 0;
      for (m = 0; m < Matrice[no].row; m++)
	{
	  for (n = 0; n < Matrice[no].col; n++)
	    {
	      if (m == n)
		{
		  det = Matrice[no].matrice[m][n];
		  o = o + det;
		}
	    }
	}
      funprint(no);
      printf("\ntr[%s]nn=tr[%s]%dx%d= %3.2f\n"
	     , Matrice[no].name, Matrice[no].name, Matrice[no].row, Matrice[no].col, o);
    } else fundimerr(no);
  return;
}
//Multiplica un escalar por los elementos de una matriz, puedes asignar
//el valor a otra matriz o puedes aplicar los cambios a la misma matriz
funescal(int no)
{
  float escalar;
  scanf("%f", &escalar);
  no = funarchm();
  printf("%3.2f*[%s]mn=[%s]%dx%d=\n", escalar, Matrice[no].name, Matrice[no].name, Matrice[no].row, Matrice[no].col);
  for (m = 0; m < Matrice[no].row; m++)
    {
      putchar('\t');
      for(n = 0; n < Matrice[no].col; n++)
	{
	  Result[m][n] = escalar * Matrice[no].matrice[m][n];
	  Matrice[ARRAY].matrice[m][n] = escalar * Matrice[no].matrice[m][n];
	  printf("%3.2f  ", Result[m][n]);
	}
      putchar('\n');
    }
  printf("Aplicar la multiplicacion a la matriz (s/n)? ");
  char n_y = getchar();
  if ((n_y = getchar()) == 's')
    {
      for (m = 0; m < Matrice[no].row; m++)
	for(n = 0; n < Matrice[no].col; n++)
	  {
	    Matrice[no].matrice[m][n] = escalar * Matrice[no].matrice[m][n];
	    Result[m][n] = escalar * Matrice[no].matrice[m][n];
	  }
      printf("Aplicacion exitosa.\n");
      return;
    }
  printf("Asgnar el resultado a otra matriz (s/n)? ");
  n_y = getchar();
  if ((n_y = getchar()) == 's')
    {
      printf("Escribe el nombre de la matriz? ");
      char name[NAMELEN], s_copy[NAMELEN]; int no_t = k++;
      scanf("%s", s_copy);
      strcpy(name, s_copy);
      strcpy(Matrice[no_t].name, name);
      Matrice[no_t].col = Matrice[no].col;
      Matrice[no_t].row = Matrice[no].row;
      for (m = 0; m < Matrice[no_t].row; m++)
	  for (n = 0; n < Matrice[no_t].col; n++)
	    Matrice[no_t].matrice[m][n] = Matrice[ARRAY].matrice[m][n];
      printf("Asignacion exitosa.\n");
    }
  return;
}
//muestra todas las matrices ingresadas a lo largo del uso del programa
funshowa()
{
  for(i = 0; i < k; i++)
    {
      if(Matrice[i].col > 0 && Matrice[i].row > 0)
	printf("[%s]%dx%d  ", Matrice[i].name, Matrice[i].row, Matrice[i].col);
    }
  if(k < 2) printf(" -> %d matrice", k); else printf(" -> %d matrices", k);
  putchar('\n');
  return;
}
//Muesta un mensaje de error cuando se solicita una matriz cuadrada y
//mayor a la dimensin cero
funrerr(int no)
{
  if(Matrice[no].row == 0)
    {
    repR:
      printf("Error el numero de renglones y columnas debe ser igual y mayores de cero, renglones= ");
      scanf("%d", &Matrice[no].row);
      if(Matrice[no].row < 1) goto repR;
    }
  return;
}
//Si se introduce una columna o fila con valor de cero se solicita el
//ingreso del valor nuevamente
funrcerr(int no)
{
  if(Matrice[no].row == 0)
    {
    repR:
      printf("Error en numero de renglones, renglones > 0, renglones = ");
      scanf("%d", &Matrice[no].row);
      if(Matrice[no].row < 1) goto repR;
    }
  if(Matrice[no].col == 0)
    {
    repC:
      printf("Error en numero de columnas, columnas > 0, columnas = ");
      scanf("%d", &Matrice[no].col);
      if(Matrice[no].col < 1) goto repC;
    }
  return;
}
//Verifica que la dimensin en una multiplicacin se correcta debe
//ser mnxnp
fundimnc(int no_o, int no_t)
{
  char dimension[2];
  strcpy(dimension, "mn");
  if(s_copy[1] == '*') strcpy(dimension, "np");
  printf("Dimension error [%s]%dx%d %c [%s]%dx%d; debe ser [%s]mn %c [%s]%s\n"
	 , Matrice[no_o].name, Matrice[no_o].row, Matrice[no_o].col, s_copy[1]
	 , Matrice[no_t].name, Matrice[no_t].row, Matrice[no_t].col
	 , Matrice[no_o].name, s_copy[1], Matrice[no_t].name, dimension);
  return;
}
//Error de dimensin
fundimerr(int no)
{
  printf("Dimension error [%s]%dx%d, la matriz no existe.\n",
	 Matrice[no].name, Matrice[no].row, Matrice[no].col);
  return;
}
//Imprime un mensaje cuando no se introducen valores en una matriz
funwoutv()
{
  printf("Matriz sin valores, la matriz no existe.\n");
  return;
}
//Imprime la notacin matricial en modo libro de texto
funmatr(int no)
{
  printf("[%s]mn=[%s]%dx%d=\n", Matrice[no].name, Matrice[no].name,
	 Matrice[no].row, Matrice[no].col);
  return;
}
//Imprime informacin sobre los comandos de matrice>>
printHelp()
{
  puts("Introduce los elementos de una matriz de n renglones y m columnas");
  puts("sintaxis: 'Introduce el nombre de la matriz'");
  puts("\tejemplo>>A");
  puts("\tQuieres ingresar la matriz [A](y/n)?y");
  puts("\tIntroduce el numero de renglones m [A]mx_ (entero): 3");
  puts("\tIntroduce el numero de columnas n [A]_xn (entero): 3");
  puts("\tAhora ingresa los elementos por renglon.");
  puts("\tR1 3 -3 5");
  puts("\tR1 2 -2 1");
  puts("\tR1 6 -9 -4");
  puts("\ndeter: calcula el determinante de una matriz cuadrada");
  puts("sintaxis: deter 'nombre de la matriz'; det A");
  puts("\tejemplo>>deter A");
  puts("\ninver: calcula la inversa de una matriz cuadrada");
  puts("sintaxis: inver 'nombre de la matriz'; A^-1");
  puts("\tejemplo>>inver A");
  puts("\ntraza: calcula la traza de una matriz cuadrada");
  puts("sintaxis: traza 'nombre de la matriz'; tr A");
  puts("\tejemplo>>traza A");
  puts("\ntrans: muestra transpuesta de una matriz");
  puts("sintaxis: trans 'nombre de la matriz'; A^T");
  puts("\tejemplo>>trans A");
  puts("\nrand: genera una matriz con elementos aleatorios");
  puts("sintaxis: rand");
  puts("Quieres generar una matriz con elementos aleatorios (y/n)?");
  puts("\tIntroduce el nombre de la matriz (letras):");
  puts("\tIntroduce el numero de renglones m [A]mx_ (entero):");
  puts("\tIntroduce el numero de columnas n [A]_xn (entero):");
  puts("\tIntroduce el limite numerico de numeros aleatorios (entero):");
  puts("\nident: genera una matriz identidad");
  puts("sintaxis: ident  'nombre de la matriz' 'n renglones = m columnas'; A[I]");
  puts("\tejemplo>>ident A 5");
  puts("\nsum: suma dos matrices");
  puts("sintaxis: sum 'nombre de la matriz' 'nombre de la matriz'");
  puts("\tejemplo>>sum A B");
  puts("\nrest: resta dos matrices");
  puts("sintaxis: rest 'nombre de la matriz' 'nombre de la matriz'");
  puts("\tejemplo>>rest A B");
  puts("\nmult: multiplica dos matrices");
  puts("sintaxis: mult 'nombre de la matriz' 'nombre de la matriz'");
  puts("\tejemplo>>mult A B");
  puts("\nescal: multiplica una matriz por un valor numerico");
  puts("sintaxis: escal 'numero' 'nombre de la matriz'");
  puts("\tejemplo>>escal 3 D");
  puts("\nshow: muestra las matrices ingresadas en memoria");
  puts("sintaxis: show");
  puts("\tejemplo>>show");
  puts("\nhelp: despliega informacion de los comandos");
  puts("\tejemplo>>help");
  puts("\nabout: despliega informacion sobre kmatrice>>");
  puts("\tejemplo>>about");
  puts("\nquit or q: termina el programa");
  puts("\tejemplo>>quit");
  return;
}
//Imprime informacin sobre el software matrice>>
printAbout()
{
  puts("\n\tkmatrice>> 0.0.9 Algebra Lineal");
  puts("\tCopyright (C) 2014 - 2015 Daniel Arroyo");
  puts("\nThis program is free software: you can redistribute it and/or modify");
  puts("it under the terms of the GNU General Public License as published by");
  puts("the Free Software Foundation, either version 3 of the License, or");
  puts("(at your option) any later version.");
  puts("\nThis program is distributed in the hope that it will be useful,");
  puts("but WITHOUT ANY WARRANTY; without even the implied warranty of");
  puts("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the");
  puts("GNU General Public License for more details.");
  puts("\nkmatrice esta en desarrollo utilizando el siguiente software:");
  puts("Sistema Operativo: http://www.slackware.com/");
  puts("Compilador: http://gcc.gnu.org/");
  puts("Editor de texto: http://emacs.gnu.org/");
  puts("Navegador y editor html: http://www.seamonkey-project.org/");
  puts("\nCorreo electronico: kmatrice@gmail.com");
  puts("Pagina principal: http://www.kmatrice@sourceforge.net/");
  puts("Ubicacion: Mexico\n");
  return;
}
//Imprime el mensaje de bienvenida
printWelcome()
{
  puts("kmatrice>> 0.0.9 Algebra Lineal (Jul 02 2016)");
  puts("Introduce \"help\", \"about\" para informacion  o \"quit\" para terminar el programa");
  return;
}
